(ns com.aurellem.items
  (:use (com.aurellem gb-driver vbm title))
  ;; this is bullshit
  (:import [com.aurellem.gb_driver SaveState]))

(defn game-name []
  (map char (subvec (vec (memory)) 0x134 0x142)))

(def item-list-start 0xD31C)

(defn item-list [^SaveState state]
  (subvec
   (vec (memory state))
   item-list-start
   (+ item-list-start 150)))

(def item-hack-3 (read-state 77557))

(def item-code->item-name
  (hash-map
   1     :master-ball
   2     :ultra-ball
   3     :great-ball
   4     :poke-ball
   5     :town-map
   6     :bicycle
   8     :safari-ball
   9     :pokedex
   10    :moon-stone 
   11    :antidote
   12    :burn-heal
   13    :ice-heal
   14    :awakening
   15    :parlyz-heal
   16    :full-restore
   17    :max-potion
   18    :hyper-potion
   19    :super-potion
   20    :potion
   21    :boulderbadge
   22    :cascadebadge
   23    :thunderbadge
   24    :rainbowbadge
   25    :soulbadge
   26    :marshbadge
   27    :volcanobadge
   28    :earthbadge
   29    :escape-rope
   30    :repel
   31    :old-amber
   32    :fire-stone
   33    :thunderstone
   34    :water-stone
   35    :hp-up
   36    :protein
   37    :iron
   38    :carbos
   39    :calcium
   40    :rare-candy
   41    :dome-fossil
   42    :helix-fossil
   43    :secret-key
   45    :bike-voucher
   46    :x-accuracy
   47    :leaf-stone
   48    :card-key
   49    :nugget
   50    :pp-up
   51    :poke-doll
   52    :full-heal
   53    :revive
   54    :max-revive
   55    :guard-spec
   56    :super-repel
   57    :max-repel
   58    :dire-hit
   59    :coin
   60    :fresh-water
   61    :soda-pop
   62    :lemonade
   63    :s.s.ticket
   64    :gold-teeth
   65    :x-attach
   66    :x-defend
   67    :x-speed
   68    :x-special
   69    :coin-case
   70    :oaks-parcel
   71    :itemfinder
   72    :silph-scope
   73    :poke-flute
   74    :lift-key
   75    :exp.all
   76    :old-rod
   77    :good-rod
   78    :super-rod
   79    :pp-up
   80    :ether
   81    :max-ether
   82    :elixer
   83    :max-elixer
   196   :HM01
   197   :HM02
   198   :HM03
   199   :HM04
   200   :HM05
   201   :TM01
   202   :TM02
   203   :TM03
   204   :TM04
   205   :TM05
   206   :TM06
   207   :TM07
   208   :TM08
   209   :TM09
   210   :TM10
   211   :TM11
   212   :TM12
   213   :TM13
   214   :TM13
   215   :TM15
   216   :TM16
   217   :TM17
   218   :TM18
   219   :TM19
   220   :TM20
   221   :TM21
   222   :TM22
   223   :TM23
   224   :TM24
   225   :TM25
   226   :TM26
   227   :TM27
   228   :TM28
   229   :TM29
   230   :TM30
   231   :TM31
   232   :TM32
   233   :TM33
   234   :TM34
   235   :TM35
   236   :TM36
   237   :TM37
   238   :TM38
   239   :TM39
   240   :TM40
   241   :TM41
   242   :TM42
   243   :TM43
   244   :TM44
   245   :TM45
   246   :TM46
   247   :TM47
   248   :TM48
   249   :TM49
   250   :TM50
   251   :TM51
   252   :TM52
   253   :TM53
   254   :TM54
   255   :end-of-list-sentinel))

(def item-name->item-code
  (zipmap (vals item-code->item-name)
          (keys item-code->item-name)))

(defn inventory [^SaveState state]
  (let [items (item-list state)]
    (map
     (fn [[item-code quantity]]
          [(item-code->item-name item-code)
           quantity])
     (partition
      2
      (next (take-while (partial not= 255) items))))))

(defn print-inventory [^SaveState state]
  (println
   (let [inv (inventory state)]
     (reduce
      str
      (concat
       ["+-------------------+----------+\n"
        "|##| Item           | Quantity |\n"
        "+--+----------------+----------+\n"]

       (map
        (fn [index [item-name quantity]]
         (str 
          (format "|%-2d| %-14s | %3d      |\n" index
                  (apply str (rest (str item-name)))
                  quantity)))
        (range 0 (count inv)) inv)
       ["+--+----------------+----------+\n"])))))

(defn inventory-codes [inventory]
  (flatten
   (concat [(count inventory)]
           (map (fn [[item-name quantity]]
                  [(item-name->item-code item-name)
                   quantity]) inventory)
           [(item-name->item-code :end-of-list-sentinel)])))
  
(defn set-inventory [^SaveState state new-inventory]
  (set-state! state)
  (let [mem (memory state)
        inv (inventory-codes new-inventory)]
  
    (dorun (map (fn [index val]
                  (aset mem index val))
                (range item-list-start
                       (+ item-list-start (count inv))) inv))
    (write-memory! mem)
    (update-state)))
  
